package org.ksv.plugin;

import java.util.Dictionary;
import java.util.Enumeration;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;

/**
 * Shows information about KsvPlugin  
 * @author ksv
 *
 */
public class AboutKsvPlugin implements IWorkbenchWindowActionDelegate {

	private IWorkbenchWindow window;
	
	public void dispose() {
		// TODO Auto-generated method stub		
	}

	public void init(IWorkbenchWindow window) {
		this.window = window;
		
	}
	
	/**
	 * Shows information about KsvPlugin  
	 */
	@SuppressWarnings({ "unchecked" })
	public void run(IAction action) {
		if ( aboutString.equals( "" ) ) {
			Dictionary dict = Activator.getDefault().getBundle().getHeaders();
			aboutString = Activator.PLUGIN_ID + " for OpenEdge Architect\n" +
				"Release: " + versionTag + "\n" + 
				"Powered by (c) Sergey Klimov aka ksv, 2009\n\n";
				
			Object key = null;

			for(Enumeration i = dict.keys(); i.hasMoreElements(); )	 { 
				key = i.nextElement();
				String val = dict.get( key ).toString();
				if ( key.toString().equals( "Require-Bundle" ) ) {
					val = "\n    " + val.replace( ",", "\n    " );
				}				 
				if ( key.toString().equals( "Bundle-Version" ) ) {
					aboutString = aboutString.replace( versionTag, val );
				}
				aboutString += key.toString() + ": " + val + "\n";
			}		
		}
		MessageDialog.openInformation( window.getShell(), "About " + Activator.PLUGIN_ID, aboutString );		
	}
	
	public void selectionChanged(IAction action, ISelection selection) {		
	}
	
	static String aboutString = "";
	static final String versionTag = "<ver>"; 
}
