package org.ksv.plugin;

import java.lang.reflect.InvocationTargetException;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.PlatformUI;

import com.openedge.pdt.text.wizards.OENewCustomProcedureWizard;

public class KsvProcedureWizard extends OENewCustomProcedureWizard {
	/**
	 * Returns template id
	 */
    protected String getTemplateID() {
        return "org.ksv.plugin.NewKsvProcedure";
    }
    
    /**
     * Allows any extension
     */
    public void addPages() {
    	super.addPages();
    	newFilePage.setRequiredExtension( null );
    }
    
    /**
     * Restores ABL syntax highlighting after opening the new file  
     */
    protected void doOpenInEditor(final IFile fileToOpen, final IProgressMonitor monitor)
    	throws InvocationTargetException {
    	super.doOpenInEditor( fileToOpen, monitor );
    	if ( !KsvUtils.isProgressFile( fileToOpen.getFullPath().toFile() ) ) {
    		IWorkbenchPage page = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage();
    		KsvUtils.restoreAblHighlighting( page.getActiveEditor() );
    	}
    }
}
